<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\DashboardService;
use SM\Traits\TResponse;

class DashboardController extends SMCrud {

  use TResponse;

  protected $DashboardService;

  public function __construct($crudService, $environment, DashboardService $DashboardService) {
        parent::__construct($crudService, $environment);
        $this->DashboardService = $DashboardService;
  }

  public function getApprovedContracts(DTO\Request $request, DTO\Response $response) {
      $chart = $this->DashboardService->getApprovedContracts($request->getParameters());
      $dtsVal = new DataSet('chart', $chart);
      $response->addDataSet($dtsVal);
  }

  public function getTerminatedContracts(DTO\Request $request, DTO\Response $response) {
      $chart = $this->DashboardService->getTerminatedContracts($request->getParameters());
      $dtsVal = new DataSet('chart', $chart);
      $response->addDataSet($dtsVal);
  }

  public function getRenegotiatedContracts(DTO\Request $request, DTO\Response $response) {
      $chart = $this->DashboardService->getRenegotiatedContracts($request->getParameters());
      $dtsVal = new DataSet('chart', $chart);
      $response->addDataSet($dtsVal);
  }

  public function getContractsCloseToExpiration(Request $request, Response $response){
    try {
        $data = $this->DashboardService->getContractsCloseToExpiration();
        $this->sendResponse($data, 200);
      } catch (Exception $ex) {
        $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
     }
  }

  public function getContractsPendingBilling(Request $request, Response $response){
    try {
        $data = $this->DashboardService->getContractsPendingBilling($request->getParameters());
        $this->sendResponse($data, 200);
      } catch (Exception $ex) {
        $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
     }
  }

}
?>