<?php
namespace SM\Service;

use SM\Factory\DashboardFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;

class DashboardService {

    protected $DashboardFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (DashboardFactory $DashboardFactory, Environment $Environment, NewCode $newCode) {
        $this->DashboardFactory  = $DashboardFactory;
        $this->Environment       = $Environment;
        $this->newCode           = $newCode;
    }

    public function getApprovedContracts($parametros) {
        return $this->DashboardFactory->getApprovedContracts($parametros);
    }

    public function getTerminatedContracts($parametros) {
        return $this->DashboardFactory->getTerminatedContracts($parametros);
    }

    public function getRenegotiatedContracts($parametros) {
        return $this->DashboardFactory->getRenegotiatedContracts($parametros);
    }

    public function getContractsCloseToExpiration() {
        return $this->DashboardFactory->getContractsCloseToExpiration();
    }

    public function getContractsPendingBilling($parametros) {

        $params = array(
            "DTINI" => ($parametros['DTINI'] == 1) ? null : $parametros['DTINI'],
            "DTFIN" => ($parametros['DTFIN'] == 1) ? null : $parametros['DTFIN']
        );

        return $this->DashboardFactory->getContractsPendingBilling($params);
    }
}