/* eslint-disable */
import {
  Loader, Metadata,
} from '@zeedhi/core';
import {
  Button, DateRange, Modal, ModalService,
} from '@zeedhi/common';

export class DashboardController{
  private modalFilter!: Modal;

  private openingMode: any;

  public ContractsController = Loader.getInstance('FrameContractsController');

  public async openModal({ component }: any) {
    this.modalFilter = await ModalService.createFromJson('/dashboard/modal/modal-filter', true);
    this.modalFilter.show();
    this.openingMode = component.name;
  }

  public closeModal() {
    this.modalFilter.hide();
    this.modalFilter?.destroy();
  }

  public teste() {
    const dateRange = {
      component: Metadata.getInstance<DateRange>('selectDate-modalFilter'),
    };

    if(this.openingMode === 'btn-filter-ApprovedContracts') {
      this.ContractsController.mountChartAprovedContracts(dateRange);
      this.closeModal();
    } else if (this.openingMode === 'btn-filter-terminatedContracts') {
      this.ContractsController.mountChartTerminatedContracts(dateRange);
      this.closeModal();
    } else if (this.openingMode === 'btn-filter-contractsPendingBilling') {
      this.ContractsController.setFilterCard(dateRange);
      this.closeModal();
    }
  }

  public nextPage({ component }: any) {
    component.parent.datasource.page += 1;
    if (component.parent.paginationLength === component.parent.datasource.page) {
      component.disabled = true;
    }
    component.parent.datasource.get();
    Metadata.getInstance<Button>(`previous-page_${component.name.split('_')[1]}`).disabled = false;
  }

  public previousPage({ component }: any) {
    if (component.parent.datasource.page > 1) {
      component.parent.datasource.page -= 1;
      if (component.parent.datasource.page === 1) {
        component.disabled = true;
      }
      component.parent.datasource.get();
      Metadata.getInstance<Button>(`next-page_${component.name.split('_')[1]}`).disabled = false;
    }
  }
}
