/* eslint-disable */
import {
  Http, IDictionary, IEventParam, Metadata, Router,
} from '@zeedhi/core';
import {
  ApexChart, DateRange,
} from '@zeedhi/common';
import {
  IterableComponentRender,
} from '@zeedhi/teknisa-components-common';

export class FrameContractsController {
  public async mountCharts({ component }: any, route: string, date: any) {
    // const dateRange = Metadata.getInstance<DateRange>('range-dashboard').value;
    const dataLabels: any = [];
    const dataSeries: any = [];

    await Http.post(route, {
      DTINICIO: (date === '' || date.length < 1) ? null : date[0],
      DTFINAL: (date === '' || date.length < 2) ? null : date[1],
    }).then((response: IDictionary) => {
      if (response.data.dataset.chart.length) {
        response.data.dataset.chart.forEach((dados: IDictionary) => {
          dataLabels.push((dados.NMTIPOORCAMENTO.length > 20) ? dados.NMTIPOORCAMENTO.substr(0, 20) + '...' : dados.NMTIPOORCAMENTO);
          dataSeries.push(dados.QUANTIDADE);
        });
      } else {
        dataLabels.push('Nenhum dado disponível');
        dataSeries.push(100);
      }
    });
    const options = {series: dataSeries, labels: dataLabels};
    component.updateChart(options);
  }

  public mountChartAprovedContracts({ component }: any) {
    const cApproved = Metadata.getInstance<ApexChart>('donut-chart-ApprovedContracts');
    const route = '/approvedContracts';
    const date = (component.component === 'ZdDateRange') ? component.value : '';
    this.mountCharts({ component: cApproved }, route, date);
  }

  public mountChartTerminatedContracts({ component }: any) {
    const cTerminated = Metadata.getInstance<ApexChart>('donut-chart-terminatedContracts');
    const route = '/terminatedContracts';
    const date = (component.component === 'ZdDateRange') ? component.value : '';
    this.mountCharts({ component: cTerminated }, route, date);
  }

  public mountChartRenegotiatedContracts({ component }: any) {
    const cRenegotiated = Metadata.getInstance<ApexChart>('donut-chart-renegotiatedContracts');
    const route = '/renegotiatedContracts';
    const date = (component.component === 'ZdDateRange') ? component.value : '';
    this.mountCharts({ component: cRenegotiated }, route, date);
  }

  public filterGeneric({component}: any) {
    this.mountChartAprovedContracts({ component });
    this.mountChartTerminatedContracts({ component });
    this.mountChartRenegotiatedContracts({ component });
    this.setFilterCard({ component });
  }

  /*public teste() {
    data = {
      ESCOPO:
      SITUACAO: APROVADO
    }
    this.sendMessage('oi');
  }*/

  public sendMessage(data:Object) {
    window.parent.postMessage({
        type: 'DashboardNext-charts',
        realData: data,
    }, window.location.ancestorOrigins[0]);
  }

  public chartMounted({ component }: IEventParam<ApexChart>) {
    const options = {
      chart: {
        events: {
          click: this.clickEvent,
        },
      },
    };
    component.updateChart(options);
  }

  public clickEvent(contex :any) {
    console.log(contex);
  }

  public setFilterCard({ component }: any) {
    const tekIterable = Metadata.getInstance<IterableComponentRender>('tekCard-contractsPendingBilling');
    const dateComp = (component.component === 'ZdDateRange') ? component.value : '';
    const date1 = (dateComp === '' || dateComp.length < 1) ? 1 : dateComp[0];
    const date2 = (dateComp === '' || dateComp.length < 2) ? 1 : dateComp[1];

    tekIterable.datasource.setFilter({
      DTINI: date1,
      DTFIN: date2,
    });
    tekIterable.datasource.get();
  }

}
